Whamcloud - gitweb
LU-12787 tests: skip project quota if it is disabled
[fs/lustre-release.git] / lustre / tests / sanity-quota.sh
index 12ad793..4689018 100755 (executable)
@@ -3,22 +3,32 @@
 # Run select tests by setting ONLY, or as arguments to the script.
 # Skip specific tests by setting EXCEPT.
 #
-# Run test by setting NOSETUP=true when ltest has setup env for us
 set -e
 
-SRCDIR=$(dirname $0)
-export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/../utils:$PATH:/sbin
-
 ONLY=${ONLY:-"$*"}
-# Bug number for skipped test:
-ALWAYS_EXCEPT="$SANITY_QUOTA_EXCEPT"
+
+LUSTRE=${LUSTRE:-$(dirname $0)/..}
+. $LUSTRE/tests/test-framework.sh
+init_test_env $@
+init_logging
+
+ALWAYS_EXCEPT="$SANITY_QUOTA_EXCEPT "
+# Bug number for skipped test:  LU-5152
+ALWAYS_EXCEPT+="                55"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
-[ "$ALWAYS_EXCEPT$EXCEPT" ] &&
-       echo "Skipping tests: $ALWAYS_EXCEPT $EXCEPT"
+# Test duration:                   30 min
+[ "$SLOW" = "no" ] && EXCEPT_SLOW="61"
 
-TMP=${TMP:-/tmp}
+if [ "$mds1_FSTYPE" = zfs ]; then
+       # bug number:                        LU-2887
+       # Test duration:                     21      9 min"
+       [ "$SLOW" = "no" ] && EXCEPT_SLOW+=" 12a     9"
+fi
 
+build_test_filter
+
+DIRECTIO=${DIRECTIO:-$LUSTRE/tests/directio}
 ORIG_PWD=${PWD}
 TSTID=${TSTID:-60000}
 TSTID2=${TSTID2:-60001}
@@ -30,34 +40,16 @@ MAX_DQ_TIME=604800
 MAX_IQ_TIME=604800
 QTYPE="ugp"
 
-LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
-. $LUSTRE/tests/test-framework.sh
-init_test_env $@
-. ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
-init_logging
-DIRECTIO=${DIRECTIO:-$LUSTRE/tests/directio}
-
 require_dsh_mds || exit 0
 require_dsh_ost || exit 0
 
 # Does e2fsprogs support quota feature?
-if [ $(facet_fstype $SINGLEMDS) == ldiskfs ] &&
+if [ "$mds1_FSTYPE" == ldiskfs ] &&
        do_facet $SINGLEMDS "! $DEBUGFS -c -R supported_features |
                grep -q 'quota'"; then
-       skip_env "e2fsprogs doesn't support quota" && exit 0
+       skip_env "e2fsprogs doesn't support quota"
 fi
 
-if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
-# bug number for skipped test:        LU-2836 LU-6836 LU-2836
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT 3       4a      6"
-
-# bug number:     LU-2887
-       #         21  9   (min)"
-       ZFS_SLOW="12a 9"
-fi
-
-[ "$SLOW" = "no" ] && EXCEPT_SLOW="$ZFS_SLOW"
-
 QUOTALOG=${TESTSUITELOG:-$TMP/$(basename $0 .sh).log}
 
 [ "$QUOTALOG" ] && rm -f $QUOTALOG || true
@@ -71,23 +63,6 @@ export QUOTA_AUTO=0
 check_and_setup_lustre
 
 ENABLE_PROJECT_QUOTAS=${ENABLE_PROJECT_QUOTAS:-true}
-is_project_quota_supported() {
-       $ENABLE_PROJECT_QUOTAS || return 1
-       [ "$(facet_fstype $SINGLEMDS)" == "ldiskfs" ] &&
-               [ $(lustre_version_code $SINGLEMDS) -gt \
-               $(version_code 2.9.55) ] &&
-               lfs --help | grep project >&/dev/null &&
-               egrep -q "7." /etc/redhat-release && return 0
-
-       if [ "$(facet_fstype $SINGLEMDS)" == "zfs" ]; then
-               [ $(lustre_version_code $SINGLEMDS) -le \
-                       $(version_code 2.10.53) ] && return 1
-
-               $ZPOOL upgrade -v | grep project_quota && return 0
-       fi
-
-       return 1
-}
 
 SHOW_QUOTA_USER="$LFS quota -v -u $TSTUSR $DIR"
 SHOW_QUOTA_USERID="$LFS quota -v -u $TSTID $DIR"
@@ -98,8 +73,6 @@ SHOW_QUOTA_INFO_USER="$LFS quota -t -u $DIR"
 SHOW_QUOTA_INFO_GROUP="$LFS quota -t -g $DIR"
 SHOW_QUOTA_INFO_PROJID="eval is_project_quota_supported && $LFS quota -t -p $DIR"
 
-build_test_filter
-
 lustre_fail() {
        local fail_node=$1
        local fail_loc=$2
@@ -165,6 +138,7 @@ quota_scan() {
                        xargs stat 2>/dev/null)
        fi
 
+       is_project_quota_supported || return 0
        if [ "$local_ugp" == "a" -o "$local_ugp" == "p" ]; then
                $LFS quota -v -p $TSTPRJID $DIR
                log "Files for project ($TSTPRJID):"
@@ -229,7 +203,13 @@ set_mdt_qtype() {
        local cmd
        [[ "$qtype" =~ "p" ]] && ! is_project_quota_supported &&
                qtype=$(tr -d 'p' <<<$qtype)
-       do_facet mgs $LCTL conf_param $FSNAME.quota.mdt=$qtype
+
+       if [[ $PERM_CMD == *"set_param -P"* ]]; then
+               do_facet mgs $PERM_CMD \
+                       osd-*.$FSNAME-MDT*.quota_slave.enable=$qtype
+       else
+               do_facet mgs $PERM_CMD $FSNAME.quota.mdt=$qtype
+       fi
        # we have to make sure each MDT received config changes
        for mdt in ${mdts//,/ }; do
                varsvc=${mdt}_svc
@@ -253,7 +233,13 @@ set_ost_qtype() {
        local cmd
        [[ "$qtype" =~ "p" ]] && ! is_project_quota_supported &&
                qtype=$(tr -d 'p' <<<$qtype)
-       do_facet mgs $LCTL conf_param $FSNAME.quota.ost=$qtype
+
+       if [[ $PERM_CMD == *"set_param -P"* ]]; then
+               do_facet mgs $PERM_CMD \
+                       osd-*.$FSNAME-OST*.quota_slave.enable=$qtype
+       else
+               do_facet mgs $PERM_CMD $FSNAME.quota.ost=$qtype
+       fi
        # we have to make sure each OST received config changes
        for ost in ${osts//,/ }; do
                varsvc=${ost}_svc
@@ -336,23 +322,42 @@ wait_ost_reint() {
        return 0
 }
 
-disable_project_quota() {
-       is_project_quota_supported || return 0
-       [ "$(facet_fstype $SINGLEMDS)" != "ldiskfs" ] && return 0
-       stopall || error "failed to stopall (1)"
-
-       for num in $(seq $MDSCOUNT); do
-               do_facet mds$num $TUNE2FS -Q ^prj $(mdsdevname $num) ||
-                       error "tune2fs $(mdsdevname $num) failed"
-       done
+wait_grace_time() {
+       local qtype=$1
+       local flavour=$2
+       local extrasleep=${3:-5}
+       local qarg
+
+       case $qtype in
+               u|g) qarg=$TSTUSR ;;
+               p) qarg=$TSTPRJID ;;
+               *) error "get_grace_time: Invalid quota type: $qtype"
+       esac
 
-       for num in $(seq $OSTCOUNT); do
-               do_facet ost$num $TUNE2FS -Q ^prj $(ostdevname $num) ||
-                       error "tune2fs $(ostdevname $num) failed"
-       done
+       case $flavour in
+               block)
+                       time=$(lfs quota -$qtype $qarg $DIR|
+                                  awk 'NR == 3{ print $5 }'| sed 's/s$//')
+                       ;;
+               file)
+                       time=$(lfs quota -$qtype $qarg $DIR|
+                                  awk 'NR == 3{ print $9 }'| sed 's/s$//')
+                       ;;
+               *)
+                       error "Unknown quota type: $flavour"
+                       ;;
+       esac
 
-       mount
-       setupall
+       echo "Sleep through grace ..."
+       [ "$time" == "-" ] &&
+           error "Grace timeout was not set or quota not exceeded"
+       if [ "$time" == "none" ]; then
+           echo "...Grace timeout already expired"
+       else
+               let time+=$extrasleep
+               echo "...sleep $time seconds"
+               sleep $time
+       fi
 }
 
 setup_quota_test() {
@@ -372,6 +377,7 @@ cleanup_quota_test() {
        echo "Wait for unlink objects finished..."
        wait_delete_completed
        sync_all_data || true
+       reset_quota_settings
 }
 
 quota_show_check() {
@@ -405,31 +411,41 @@ quota_show_check() {
        fi
 }
 
-enable_project_quota() {
-       is_project_quota_supported || return 0
-       [ "$(facet_fstype $SINGLEMDS)" != "ldiskfs" ] && return 0
-       stopall || error "failed to stopall (1)"
+project_quota_enabled () {
+       local rc=0
+       local zfeat="feature@project_quota"
 
-       for num in $(seq $MDSCOUNT); do
-               do_facet mds$num $TUNE2FS -O project $(mdsdevname $num) ||
-                       error "tune2fs $(mdsdevname $num) failed"
-       done
+       for facet in $(seq -f mds%g $MDSCOUNT) $(seq -f ost%g $OSTCOUNT); do
+               local facet_fstype=${facet:0:3}1_FSTYPE
+               local devname
 
-       for num in $(seq $OSTCOUNT); do
-               do_facet ost$num $TUNE2FS -O project $(ostdevname $num) ||
-                       error "tune2fs $(ostdevname $num) failed"
+               if [ "${!facet_fstype}" = "zfs" ]; then
+                       devname=$(zpool_name ${facet})
+                       do_facet ${facet} $ZPOOL get -H "$zfeat" $devname |
+                               grep -wq active || rc=1
+               else
+                       [ ${facet:0:3} == "mds" ] &&
+                               devname=$(mdsdevname ${facet:3}) ||
+                               devname=$(ostdevname ${facet:3})
+                       do_facet ${facet} $DEBUGFS -R features $devname |
+                               grep -q project || rc=1
+               fi
        done
-
-       mount
-       setupall
+       [ $rc -eq 0 ] && PQ_CLEANUP=false || PQ_CLEANUP=true
+       return $rc
 }
-enable_project_quota
+
+project_quota_enabled || enable_project_quota
 
 reset_quota_settings() {
        resetquota -u $TSTUSR
+       resetquota -u $TSTID
        resetquota -g $TSTUSR
+       resetquota -g $TSTID
        resetquota -u $TSTUSR2
+       resetquota -u $TSTID2
        resetquota -g $TSTUSR2
+       resetquota -g $TSTID2
        resetquota -p $TSTPRJID
 }
 
@@ -454,15 +470,15 @@ test_quota_performance() {
        local etime=$(date +%s)
        delta=$((etime - stime))
        if [ $delta -gt 0 ]; then
-           rate=$((size * 1024 / delta))
-           if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
-               # LU-2872 - see LU-2887 for fix
-               [ $rate -gt 64 ] ||
-                       error "SLOW IO for $TSTUSR (user): $rate KB/sec"
-           else
-               [ $rate -gt 1024 ] ||
-                       error "SLOW IO for $TSTUSR (user): $rate KB/sec"
-           fi
+               rate=$((size * 1024 / delta))
+               if [ "$mds1_FSTYPE" = zfs ]; then
+                       # LU-2872 - see LU-2887 for fix
+                       [ $rate -gt 64 ] ||
+                               error "SLOW IO for $TSTUSR (user): $rate KB/sec"
+               else
+                       [ $rate -gt 1024 ] ||
+                               error "SLOW IO for $TSTUSR (user): $rate KB/sec"
+               fi
        fi
        rm -f $TESTFILE
 }
@@ -475,7 +491,7 @@ test_0() {
        local free_space=$(lfs_df | grep "summary" | awk '{print $4}')
        [ $free_space -le $((MB * 1024)) ] &&
                skip "not enough space ${free_space} KB, " \
-                       "required $((MB * 1024)) KB" && return
+                       "required $((MB * 1024)) KB"
        setup_quota_test || error "setup quota failed with $?"
        trap cleanup_quota_test EXIT
 
@@ -488,7 +504,6 @@ test_0() {
        test_quota_performance $MB
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 0 "Test basic quota performance"
 
@@ -512,7 +527,7 @@ test_1() {
        local USED=$(getquota -u $TSTUSR global curspace)
        [ $USED -ne 0 ] && error "Used space($USED) for user $TSTUSR isn't 0."
 
-       $SETSTRIPE $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        log "Write..."
@@ -546,7 +561,7 @@ test_1() {
        USED=$(getquota -g $TSTUSR global curspace)
        [ $USED -ne 0 ] && error "Used space ($USED) for group $TSTUSR isn't 0"
 
-       $SETSTRIPE $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        log "Write ..."
@@ -585,7 +600,7 @@ test_1() {
        $LFS setquota -p $TSTPRJID -b 0 -B ${LIMIT}M -i 0 -I 0 $DIR ||
                error "set project quota failed"
 
-       $SETSTRIPE $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR:$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
        change_project -p $TSTPRJID $TESTFILE
 
@@ -604,10 +619,8 @@ test_1() {
        cleanup_quota_test
 
        USED=$(getquota -p $TSTPRJID global curspace)
-       [ $USED -ne 0 ] && quota_error p $TSTPRJID \
+       [ $USED -eq 0 ] || quota_error p $TSTPRJID \
                "project quota isn't released after deletion"
-
-       resetquota -p $TSTPRJID
 }
 run_test 1 "Block hard limit (normal use and out of quota)"
 
@@ -621,8 +634,7 @@ test_2() {
        local FREE_INODES=$(mdt_free_inodes 0)
        echo "$FREE_INODES free inodes on master MDT"
        [ $FREE_INODES -lt $LIMIT ] &&
-               skip "not enough free inodes $FREE_INODES required $LIMIT" &&
-               return
+               skip "not enough free inodes $FREE_INODES required $LIMIT"
 
        setup_quota_test || error "setup quota failed with $?"
        trap cleanup_quota_test EXIT
@@ -710,17 +722,15 @@ test_2() {
 
        cleanup_quota_test
        USED=$(getquota -p $TSTPRJID global curinodes)
-       [ $USED -ne 0 ] && quota_error p $TSTPRJID \
+       [ $USED -eq 0 ] || quota_error p $TSTPRJID \
                "project quota isn't released after deletion"
 
-       resetquota -p $TSTPRJID
-
 }
 run_test 2 "File hard limit (normal use and out of quota)"
 
 test_block_soft() {
        local TESTFILE=$1
-       local TIMER=$(($2 * 3 / 2))
+       local GRACE=$2
        local LIMIT=$3
        local OFFSET=0
        local qtype=$4
@@ -728,7 +738,7 @@ test_block_soft() {
        setup_quota_test
        trap cleanup_quota_test EXIT
 
-       $SETSTRIPE $TESTFILE -c 1 -i 0
+       $LFS setstripe $TESTFILE -c 1 -i 0
        chown $TSTUSR.$TSTUSR $TESTFILE
        [ "$qtype" == "p" ] && is_project_quota_supported &&
                change_project -p $TSTPRJID $TESTFILE
@@ -758,8 +768,7 @@ test_block_soft() {
        OFFSET=$((OFFSET + 1024))
        cancel_lru_locks osc
 
-       echo "Sleep $TIMER seconds ..."
-       sleep $TIMER
+       wait_grace_time $qtype "block"
 
        $SHOW_QUOTA_USER
        $SHOW_QUOTA_GROUP
@@ -795,7 +804,7 @@ test_block_soft() {
        $SHOW_QUOTA_INFO_GROUP
        $SHOW_QUOTA_INFO_PROJID
 
-       $SETSTRIPE $TESTFILE -c 1 -i 0
+       $LFS setstripe $TESTFILE -c 1 -i 0
        chown $TSTUSR.$TSTUSR $TESTFILE
        [ "$qtype" == "p" ] && change_project -p $TSTPRJID $TESTFILE
 
@@ -808,10 +817,16 @@ test_block_soft() {
 
 # block soft limit
 test_3() {
-       local LIMIT=1  # 1MB
        local GRACE=20 # 20s
+       if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
+           GRACE=60
+       fi
        local TESTFILE=$DIR/$tdir/$tfile-0
 
+       # get minimum soft qunit size
+       local LIMIT=$(( $(do_facet $SINGLEMDS $LCTL get_param -n \
+               qmt.$FSNAME-QMT0000.dt-0x0.soft_least_qunit) / 1024 ))
+
        set_ost_qtype $QTYPE || error "enable ost quota failed"
 
        echo "User quota (soft limit:$LIMIT MB  grace:$GRACE seconds)"
@@ -825,7 +840,6 @@ test_3() {
                error "set user quota failed"
 
        test_block_soft $TESTFILE $GRACE $LIMIT "u"
-       resetquota -u $TSTUSR
 
        echo "Group quota (soft limit:$LIMIT MB  grace:$GRACE seconds)"
        TESTFILE=$DIR/$tdir/$tfile-1
@@ -839,7 +853,6 @@ test_3() {
                error "set group quota failed"
 
        test_block_soft $TESTFILE $GRACE $LIMIT "g"
-       resetquota -g $TSTUSR
 
        if is_project_quota_supported; then
                echo "Project quota (soft limit:$LIMIT MB  grace:$GRACE sec)"
@@ -874,7 +887,7 @@ test_file_soft() {
        local TESTFILE=$1
        local LIMIT=$2
        local grace=$3
-       local TIMER=$(($grace * 3 / 2))
+       local qtype=$4
 
        setup_quota_test
        trap cleanup_quota_test EXIT
@@ -897,8 +910,7 @@ test_file_soft() {
                        "but expect success. $trigger_time, $cur_time"
        sync_all_data || true
 
-       echo "Sleep $TIMER seconds ..."
-       sleep $TIMER
+       wait_grace_time $qtype "file"
 
        $SHOW_QUOTA_USER
        $SHOW_QUOTA_GROUP
@@ -941,7 +953,8 @@ test_file_soft() {
 
 # file soft limit
 test_4a() {
-       local LIMIT=10 # inodes
+       local LIMIT=$(do_facet $SINGLEMDS $LCTL get_param -n \
+               qmt.$FSNAME-QMT0000.md-0x0.soft_least_qunit)
        local TESTFILE=$DIR/$tdir/$tfile-0
        local GRACE=12
 
@@ -957,8 +970,9 @@ test_4a() {
        $LFS setquota -u $TSTUSR -b 0 -B 0 -i $LIMIT -I 0 $DIR ||
                error "set user quota failed"
 
-       test_file_soft $TESTFILE $LIMIT $GRACE
-       resetquota -u $TSTUSR
+       [ "$mds1_FSTYPE" = zfs ] && GRACE=20
+
+       test_file_soft $TESTFILE $LIMIT $GRACE "u"
 
        echo "Group quota (soft limit:$LIMIT files  grace:$GRACE seconds)"
        # make sure the system is clean
@@ -971,8 +985,7 @@ test_4a() {
                error "set group quota failed"
        TESTFILE=$DIR/$tdir/$tfile-1
 
-       test_file_soft $TESTFILE $LIMIT $GRACE
-       resetquota -g $TSTUSR
+       test_file_soft $TESTFILE $LIMIT $GRACE "g"
 
        if is_project_quota_supported; then
                echo "Project quota (soft limit:$LIMIT files grace:$GRACE sec)"
@@ -988,7 +1001,7 @@ test_4a() {
 
                TESTFILE=$DIR/$tdir/$tfile-1
                # one less than limit, because of parent directory included.
-               test_file_soft $TESTFILE $((LIMIT-1)) $GRACE
+               test_file_soft $TESTFILE $((LIMIT-1)) $GRACE "p"
                resetquota -p $TSTPRJID
                $LFS setquota -t -p --block-grace $MAX_DQ_TIME --inode-grace \
                        $MAX_IQ_TIME $DIR ||
@@ -1097,10 +1110,6 @@ test_5() {
        unlinkmany $DIR/$tdir/$tfile-0_ $((ILIMIT + 1)) ||
                error "unlinkmany $DIR/$tdir/$tfile-0_ failed"
        cleanup_quota_test
-
-       resetquota -u $TSTUSR
-       resetquota -g $TSTUSR
-       resetquota -p $TSTPRJID
 }
 run_test 5 "Chown & chgrp successfully even out of block/file quota"
 
@@ -1125,12 +1134,12 @@ test_6() {
 
        # create file for $TSTUSR
        local TESTFILE=$DIR/$tdir/$tfile-$TSTUSR
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        # create file for $TSTUSR2
        local TESTFILE2=$DIR/$tdir/$tfile-$TSTUSR2
-       $SETSTRIPE $TESTFILE2 -c 1 -i 0 || error "setstripe $TESTFILE2 failed"
+       $LFS setstripe $TESTFILE2 -c 1 -i 0 || error "setstripe $TESTFILE2 failed"
        chown $TSTUSR2.$TSTUSR2 $TESTFILE2 || error "chown $TESTFILE2 failed"
 
        # cache per-ID lock for $TSTUSR on slave
@@ -1140,6 +1149,19 @@ test_6() {
                error "write $TESTFILE failure, expect success"
        $RUNAS2 $DD of=$TESTFILE2 count=1 ||
                error "write $TESTFILE2 failure, expect success"
+
+       if at_is_enabled; then
+               at_max_saved=$(at_max_get ost1)
+               at_max_set $TIMEOUT ost1
+
+               # write to enforced ID ($TSTUSR) to exceed limit to make sure
+               # DQACQ is sent, which makes at_max to take effect
+               $RUNAS $DD of=$TESTFILE count=$LIMIT seek=1 oflag=sync \
+                                                               conv=notrunc
+               rm -f $TESTFILE
+               wait_delete_completed
+       fi
+
        sync; sync
        sync_all_data || true
 
@@ -1147,6 +1169,9 @@ test_6() {
        #define OBD_FAIL_PTLRPC_DROP_REQ_OPC 0x513
        lustre_fail mds 0x513 601
 
+       do_facet ost1 $LCTL set_param \
+                       osd-*.$FSNAME-OST*.quota_slave.timeout=$((TIMEOUT / 2))
+
        # write to un-enforced ID ($TSTUSR2) should succeed
        $RUNAS2 $DD of=$TESTFILE2 count=$LIMIT seek=1 oflag=sync conv=notrunc ||
                error "write failure, expect success"
@@ -1160,6 +1185,8 @@ test_6() {
        echo "Sleep for $((TIMEOUT * 2 + 1)) seconds ..."
        sleep $((TIMEOUT * 2 + 1))
 
+       [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
+
        # write should be blocked and never finished
        if ! ps -p $DDPID  > /dev/null 2>&1; then
                lustre_fail mds 0 0
@@ -1170,7 +1197,7 @@ test_6() {
 
        # no watchdog is triggered
        do_facet ost1 dmesg > $TMP/lustre-log-${TESTNAME}.log
-       watchdog=$(awk '/Service thread pid/ && /was inactive/ \
+       watchdog=$(awk '/[Ss]ervice thread pid/ && /was inactive/ \
                        { print; }' $TMP/lustre-log-${TESTNAME}.log)
        [ -z "$watchdog" ] || error "$watchdog"
 
@@ -1194,7 +1221,6 @@ test_6() {
        done
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 6 "Test dropping acquire request on master"
 
@@ -1223,7 +1249,7 @@ test_7a() {
                error "limit($USED) on $OSTUUID for user $TSTUSR isn't 0"
 
        # create test file
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        echo "Stop ost1..."
@@ -1267,7 +1293,6 @@ test_7a() {
                quota_error u $TSTUSR "write error, but expect success"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 7a "Quota reintegration (global index)"
 
@@ -1294,7 +1319,7 @@ test_7b() {
                error "limit($USED) on $OSTUUID for user $TSTUSR isn't 0"
 
        # create test file
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        # consume some space to make sure the granted space will not
@@ -1327,7 +1352,6 @@ test_7b() {
        [ $USED -gt $old_used ] || error "limit on $OSTUUID $USED <= $old_used"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
        $SHOW_QUOTA_USER
 }
 run_test 7b "Quota reintegration (slave index)"
@@ -1356,7 +1380,7 @@ test_7c() {
        # enable ost quota
        set_ost_qtype $QTYPE || error "enable ost quota failed"
        # trigger reintegration
-       local procf="osd-$(facet_fstype ost1).$FSNAME-OST*."
+       local procf="osd-$ost1_FSTYPE.$FSNAME-OST*."
        procf=${procf}quota_slave.force_reint
        do_facet ost1 $LCTL set_param $procf=1 ||
                error "force reintegration failed"
@@ -1380,7 +1404,6 @@ test_7c() {
                quota_error u $TSTUSR "write success, but expect EDQUOT"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 7c "Quota reintegration (restart mds during reintegration)"
 
@@ -1417,25 +1440,22 @@ test_7d(){
                quota_error u $TSTUSR2 "$TSTUSR2 write success, expect EDQUOT"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
-       resetquota -u $TSTUSR2
 }
 run_test 7d "Quota reintegration (Transfer index in multiple bulks)"
 
 # quota reintegration (inode limits)
 test_7e() {
-       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs" && return
+       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs"
 
        # LU-2435: skip this quota test if underlying zfs version has not
        # supported native dnode accounting
-       [ "$(facet_fstype mds1)" == "zfs" ] && {
+       [ "$mds1_FSTYPE" == zfs ] && {
                local F="feature@userobj_accounting"
                local pool=$(zpool_name mds1)
                local feature=$(do_facet mds1 $ZPOOL get -H $F $pool)
 
                [[ "$feature" != *" active "* ]] &&
-                       skip "requires zpool with active userobj_accounting" &&
-                       return
+                       skip "requires zpool with active userobj_accounting"
        }
 
        local ilimit=$((1024 * 2)) # 2k inodes
@@ -1506,7 +1526,6 @@ test_7e() {
        rmdir $DIR/${tdir}-1 || error "unlink remote dir failed"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 7e "Quota reintegration (inode limits)"
 
@@ -1542,9 +1561,6 @@ test_8() {
 
        is_project_quota_supported && change_project -C $DIR/$tdir
        cleanup_quota_test
-       resetquota -u $TSTUSR
-       resetquota -g $TSTUSR
-       resetquota -p $TSTPRJID
 }
 run_test 8 "Run dbench with quota enabled"
 
@@ -1593,7 +1609,7 @@ test_9() {
        quota_show_check a g $TSTUSR
 
        echo "Create test file"
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        log "Write the big file of 4.5G ..."
@@ -1604,8 +1620,6 @@ test_9() {
        $SHOW_QUOTA_GROUP
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
-       resetquota -g $TSTUSR
 
        $SHOW_QUOTA_USER
        $SHOW_QUOTA_GROUP
@@ -1633,14 +1647,13 @@ test_10() {
                error "set quota failed"
        quota_show_check b u $TSTUSR
 
-       $SETSTRIPE $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        runas -u 0 -g 0 $DD of=$TESTFILE count=3 oflag=sync ||
                error "write failure, expect success"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 10 "Test quota for root user"
 
@@ -1664,12 +1677,11 @@ test_11() {
        [ $USED -ge 2 ] || error "Used inodes($USED) is less than 2"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 11 "Chown/chgrp ignores quota"
 
 test_12a() {
-       [ "$OSTCOUNT" -lt "2" ] && skip "needs >= 2 OSTs" && return
+       [ "$OSTCOUNT" -lt "2" ] && skip "needs >= 2 OSTs"
 
        local blimit=22 # 22M
        local blk_cnt=$((blimit - 5))
@@ -1685,8 +1697,8 @@ test_12a() {
        $LFS setquota -u $TSTUSR -b 0 -B "$blimit"M -i 0 -I 0 $DIR ||
                error "set quota failed"
 
-       $SETSTRIPE $TESTFILE0 -c 1 -i 0 || error "setstripe $TESTFILE0 failed"
-       $SETSTRIPE $TESTFILE1 -c 1 -i 1 || error "setstripe $TESTFILE1 failed"
+       $LFS setstripe $TESTFILE0 -c 1 -i 0 || error "setstripe $TESTFILE0 failed"
+       $LFS setstripe $TESTFILE1 -c 1 -i 1 || error "setstripe $TESTFILE1 failed"
        chown $TSTUSR.$TSTUSR $TESTFILE0 || error "chown $TESTFILE0 failed"
        chown $TSTUSR.$TSTUSR $TESTFILE1 || error "chown $TESTFILE1 failed"
 
@@ -1708,12 +1720,11 @@ test_12a() {
                quota_error a $TSTUSR "rebalancing failed"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 12a "Block quota rebalancing"
 
 test_12b() {
-       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs" && return
+       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs"
 
        local ilimit=$((1024 * 2)) # 2k inodes
        local TESTFILE0=$DIR/$tdir/$tfile
@@ -1753,7 +1764,6 @@ test_12b() {
        rmdir $DIR/${tdir}-1 || error "unlink remote dir failed"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 12b "Inode quota rebalancing"
 
@@ -1770,7 +1780,7 @@ test_13(){
 
        $LFS setquota -u $TSTUSR -b 0 -B 10M -i 0 -I 0 $DIR ||
                error "set quota failed"
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        # clear the locks in cache first
@@ -1884,7 +1894,6 @@ test_17sub() {
                "Used space(${USED}K) is less than ${BLKS}M"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 
 # DQACQ return recoverable error
@@ -1922,7 +1931,7 @@ test_18_sub () {
                error "set quota failed"
        quota_show_check b u $TSTUSR
 
-       $SETSTRIPE $TESTFILE -i 0 -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -i 0 -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        local timeout=$(sysctl -n lustre.timeout)
@@ -1967,7 +1976,6 @@ test_18_sub () {
                        "got ${testfile_size}. Verifying file failed!"
        fi
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 
 # test when mds does failover, the ost still could work well
@@ -1982,7 +1990,7 @@ test_18() {
 
        # check if watchdog is triggered
        do_facet ost1 dmesg > $TMP/lustre-log-${TESTNAME}.log
-       local watchdog=$(awk '/Service thread pid/ && /was inactive/ \
+       local watchdog=$(awk '/[Ss]ervice thread pid/ && /was inactive/ \
                        { print; }' $TMP/lustre-log-${TESTNAME}.log)
        [ -z "$watchdog" ] || error "$watchdog"
        rm -f $TMP/lustre-log-${TESTNAME}.log
@@ -1999,7 +2007,7 @@ test_19() {
        set_ost_qtype $QTYPE || error "enable ost quota failed"
 
        # bind file to a single OST
-       $SETSTRIPE -c 1 $TESTFILE || error "setstripe $TESTFILE failed"
+       $LFS setstripe -c 1 $TESTFILE || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        echo "Set user quota (limit: ${blimit}M)"
@@ -2020,7 +2028,6 @@ test_19() {
        $SHOW_QUOTA_USER
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 19 "Updating admin limits doesn't zero operational limits(b14790)"
 
@@ -2137,9 +2144,6 @@ test_21() {
        echo "(dd_pid=$DDPID2, time=$count)successful"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
-       resetquota -g $TSTUSR
-       resetquota -p $TSTPRJID
 }
 run_test 21 "Setquota while writing & deleting (b16053)"
 
@@ -2158,7 +2162,7 @@ test_22() {
 
        echo "Verify if quota is enabled"
        local qtype1=$(mdt_quota_type)
-       [ $qtype1 != $qtype] && error "mdt quota setting is lost"
+       [ $qtype1 != $qtype ] && error "mdt quota setting is lost"
        qtype=$(ost_quota_type)
        [ $qtype1 != $qtype ] && error "ost quota setting is lost"
 
@@ -2180,7 +2184,7 @@ test_22() {
 
        return 0
 }
-run_test 22 "enable/disable quota by 'lctl conf_param'"
+run_test 22 "enable/disable quota by 'lctl conf_param/set_param -P'"
 
 test_23_sub() {
        local TESTFILE="$DIR/$tdir/$tfile"
@@ -2197,7 +2201,7 @@ test_23_sub() {
                error "set quota failed"
        quota_show_check b u $TSTUSR
 
-       $SETSTRIPE $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 -i 0 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        log "Step1: trigger EDQUOT with O_DIRECT"
@@ -2226,13 +2230,12 @@ test_23_sub() {
                ($SHOW_QUOTA_USER; \
                quota_error u $TSTUSR "quota isn't released")
        $SHOW_QUOTA_USER
-       resetquota -u $TSTUSR
 }
 
 test_23() {
-       [ $(facet_fstype ost1) == "zfs" ] &&
+       [ "$ost1_FSTYPE" == zfs ] &&
                skip "Overwrite in place is not guaranteed to be " \
-               "space neutral on ZFS" && return
+               "space neutral on ZFS"
 
        local OST0_MIN=$((6 * 1024)) # 6MB, extra space for meta blocks.
        check_whether_skip && return 0
@@ -2256,7 +2259,7 @@ test_24() {
        set_ost_qtype $QTYPE || error "enable ost quota failed"
 
        # bind file to a single OST
-       $SETSTRIPE -c 1 $TESTFILE || error "setstripe $TESTFILE failed"
+       $LFS setstripe -c 1 $TESTFILE || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        echo "Set user quota (limit: ${blimit}M)"
@@ -2272,7 +2275,6 @@ test_24() {
        $SHOW_QUOTA_USER | grep '*' || error "no matching *"
 
        cleanup_quota_test
-       resetquota -u $TSTUSR
 }
 run_test 24 "lfs draws an asterix when limit is reached (b16646)"
 
@@ -2301,8 +2303,8 @@ test_27b() { # b20200
                $SHOW_QUOTA_PROJID ||
                        error "lfs quota failed with projid argument"
        fi
-       resetquota -u $TSTUSR
-       resetquota -g $TSTUSR
+       resetquota -u $TSTID
+       resetquota -g $TSTID
        resetquota -p $TSTPRJID
        return 0
 }
@@ -2360,7 +2362,7 @@ test_30() {
 
        set_ost_qtype "u" || error "enable ost quota failed"
 
-       $SETSTRIPE $TESTFILE -i 0 -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -i 0 -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        $LFS setquota -t -u --block-grace $GRACE --inode-grace \
@@ -2382,7 +2384,6 @@ test_30() {
                error "grace times were reset"
        # cleanup
        cleanup_quota_test
-       resetquota -u $TSTUSR
        $LFS setquota -t -u --block-grace $MAX_DQ_TIME --inode-grace \
                $MAX_IQ_TIME $DIR || error "restore grace time failed"
 }
@@ -2673,8 +2674,8 @@ run_test 35 "Usage is still accessible across reboot"
 # chown/chgrp to the file created with MDS_OPEN_DELAY_CREATE
 # LU-5006
 test_37() {
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.93) ] &&
-               skip "Old server doesn't have LU-5006 fix." && return
+       [ "$MDS1_VERSION" -lt $(version_code 2.6.93) ] &&
+               skip "Old server doesn't have LU-5006 fix."
 
        setup_quota_test || error "setup quota failed with $?"
        trap cleanup_quota_test EXIT
@@ -2685,7 +2686,7 @@ test_37() {
                error "Used space ($USED) for user $TSTID isn't 0."
 
        # create file with MDS_OPEN_DELAY_CREATE flag
-       $SETSTRIPE -c 1 -i 0 $DIR/$tdir/$tfile ||
+       $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile ||
                error "Create file failed"
        # write to file
        dd if=/dev/zero of=$DIR/$tdir/$tfile bs=1M count=1 conv=notrunc \
@@ -2705,8 +2706,8 @@ run_test 37 "Quota accounted properly for file created by 'lfs setstripe'"
 
 # LU-8801
 test_38() {
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.8.60) ] &&
-               skip "Old server doesn't have LU-8801 fix." && return
+       [ "$MDS1_VERSION" -lt $(version_code 2.8.60) ] &&
+               skip "Old server doesn't have LU-8801 fix."
 
        [ "$UID" != 0 ] && skip_env "must run as root" && return
 
@@ -2734,7 +2735,7 @@ test_38() {
        cancel_lru_locks osc
        sync; sync_all_data || true
 
-       local procf="osd-$(facet_fstype $SINGLEMDS).$FSNAME-MDT0000"
+       local procf="osd-$mds1_FSTYPE.$FSNAME-MDT0000"
        procf=${procf}.quota_slave.acct_user
        local accnt_cnt
 
@@ -2754,7 +2755,7 @@ run_test 38 "Quota accounting iterator doesn't skip id entries"
 test_39() {
        local TESTFILE="$DIR/$tdir/project"
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
 
        setup_quota_test || error "setup quota failed with $?"
 
@@ -2780,7 +2781,7 @@ run_test 39 "Project ID interface works correctly"
 
 test_40a() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        local dir1="$DIR/$tdir/dir1"
        local dir2="$DIR/$tdir/dir2"
 
@@ -2800,7 +2801,7 @@ run_test 40a "Hard link across different project ID"
 
 test_40b() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        local dir1="$DIR/$tdir/dir1"
        local dir2="$DIR/$tdir/dir2"
 
@@ -2820,9 +2821,9 @@ test_40b() {
 run_test 40b "Mv across different project ID"
 
 test_40c() {
-       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs" && return
+       [ "$MDSCOUNT" -lt "2" ] && skip "needs >= 2 MDTs"
                ! is_project_quota_supported &&
-                       skip "Project quota is not supported" && return 0
+                       skip "Project quota is not supported"
 
        setup_quota_test || error "setup quota failed with $?"
        local dir="$DIR/$tdir/dir"
@@ -2850,23 +2851,35 @@ run_test 40c "Remote child Dir inherit project quota properly"
 
 test_50() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
 
        setup_quota_test || error "setup quota failed with $?"
-       local dir="$DIR/$tdir/dir"
+       local dir1="$DIR/$tdir/dir1"
+       local dir2="$DIR/$tdir/dir2"
+
+       mkdir -p $dir1 && change_project -sp 1 $dir1
+       mkdir -p $dir2 && change_project -sp 2 $dir2
+       for num in $(seq 1 10); do
+               touch $dir1/file_$num $dir2/file_$num
+               ln -s $dir1/file_$num $dir1/file_$num"_link"
+               ln -s $dir2/file_$num $dir2/file_$num"_link"
+       done
 
-       mkdir $dir && change_project -p 1 $dir
        count=$($LFS find --projid 1 $DIR | wc -l)
-       [ "$count" != 1 ] && error "expected 1 but got $count"
+       [ "$count" != 21 ] && error "expected 21 but got $count"
 
-       rm -rf $dir
+       # 1(projid 0 dir) + 1(projid 2 dir) + 20(projid 2 files)
+       count=$($LFS find ! --projid 1 $DIR/$tdir | wc -l)
+       [ "$count" != 22 ] && error "expected 22 but got $count"
+
+       rm -rf $dir1 $dir2
        cleanup_quota_test
 }
 run_test 50 "Test if lfs find --projid works"
 
 test_51() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        setup_quota_test || error "setup quota failed with $?"
        local dir="$DIR/$tdir/dir"
 
@@ -2898,7 +2911,7 @@ run_test 51 "Test project accounting with mv/cp"
 
 test_52() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        setup_quota_test || error "setup quota failed with $?"
        local dir="$DIR/$tdir/dir"
        mkdir $dir && change_project -sp 1 $dir
@@ -2916,7 +2929,7 @@ run_test 52 "Rename across different project ID"
 
 test_53() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        setup_quota_test || error "setup quota failed with $?"
        local dir="$DIR/$tdir/dir"
        mkdir $dir && change_project -s $dir
@@ -2933,7 +2946,7 @@ run_test 53 "Project inherit attribute could be cleared"
 
 test_54() {
        ! is_project_quota_supported &&
-               skip "Project quota is not supported" && return 0
+               skip "Project quota is not supported"
        setup_quota_test || error "setup quota failed with $?"
        trap cleanup_quota_test EXIT
        local testfile="$DIR/$tdir/$tfile-0"
@@ -2958,8 +2971,8 @@ test_54() {
        #clear project but with kept projid
        change_project -rCk $DIR/$tdir
        proj_count1=$(lfs project -rcp $TSTPRJID $DIR/$tdir | wc -l)
-       [ $proj_count1 -eq $proj_count ] ||
-                       error "c3: expected $proj_count got $proj_count1"
+       [ $proj_count1 -eq 1 ] ||
+                       error "c3: expected 1 got $proj_count1"
 
        #verify projid untouched.
        proj_count1=$(lfs project -r $DIR/$tdir | grep -c $TSTPRJID)
@@ -2986,8 +2999,8 @@ test_54() {
 run_test 54 "basic lfs project interface test"
 
 test_55() {
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.10.58) ] &&
-               skip "Not supported before 2.10.58." && return
+       [ "$MDS1_VERSION" -lt $(version_code 2.10.58) ] &&
+               skip "Not supported before 2.10.58."
        setup_quota_test || error "setup quota failed with $?"
 
        set_ost_qtype $QTYPE || error "enable ost quota failed"
@@ -3024,7 +3037,6 @@ test_55() {
 
        $LFS quota -v -g $TSTUSR2 $DIR
 
-       resetquota -g $TSTUSR2
        cleanup_quota_test
 }
 run_test 55 "Chgrp should be affected by group quota"
@@ -3057,23 +3069,23 @@ test_57() {
        #try to change pipe file should not hang and return failure
        wait_update_facet client "$LFS project -sp 1 $dir/pipe 2>&1 |
                awk -F ':' '{ print \\\$2 }'" \
-                       " failed to get xattr for '$dir/pipe'" || return 1
+                       " unable to get xattr for fifo '$dir/pipe'" || return 1
        #command can process further if it hit some errors
        touch $dir/aaa $dir/bbb
+       mkdir $dir/subdir -p
+       touch $dir/subdir/aaa $dir/subdir/bbb
        #create one invalid link file
        ln -s $dir/not_exist_file $dir/ccc
        local cnt=$(lfs project -r $dir 2>/dev/null | wc -l)
-       [ $cnt -eq 2 ] || error "expected 2 got $cnt"
+       [ $cnt -eq 5 ] || error "expected 5 got $cnt"
 
        cleanup_quota_test
 }
 run_test 57 "lfs project could tolerate errors"
 
 test_59() {
-       if [ $(facet_fstype $SINGLEMDS) != ldiskfs ]; then
+       [ "$mds1_FSTYPE" != ldiskfs ] &&
                skip "ldiskfs only test"
-               return
-       fi
        disable_project_quota
        setup_quota_test || error "setup quota failed with $?"
        quota_init
@@ -3088,8 +3100,11 @@ test_59() {
 run_test 59 "lfs project dosen't crash kernel with project disabled"
 
 test_60() {
+       [ $MDS1_VERSION -lt $(version_code 2.11.53) ] &&
+               skip "Needs MDS version 2.11.53 or later."
        setup_quota_test || error "setup quota failed with $?"
        trap cleanup_quota_test EXIT
+
        local testfile=$DIR/$tdir/$tfile
        local limit=100
 
@@ -3111,14 +3126,13 @@ test_60() {
                error "root user should succeed"
 
        cleanup_quota_test
-       resetquota -g $TSTUSR
 }
 run_test 60 "Test quota for root with setgid"
 
 # test default quota
 test_default_quota() {
-       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.11.51) ] &&
-               skip "Not supported before 2.11.51." && return
+       [ "$MDS1_VERSION" -lt $(version_code 2.11.51) ] &&
+               skip "Not supported before 2.11.51."
 
        local qtype=$1
        local qpool=$2
@@ -3182,7 +3196,7 @@ test_default_quota() {
        local USED=$(getquota $qtype $qid global curspace)
        [ $USED -ne 0 ] && error "Used space for $qid isn't 0."
 
-       $SETSTRIPE $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
+       $LFS setstripe $TESTFILE -c 1 || error "setstripe $TESTFILE failed"
        chown $TSTUSR.$TSTUSR $TESTFILE || error "chown $TESTFILE failed"
 
        [ $qtype == "-p" ] && change_project -sp $TSTPRJID $DIR/$tdir
@@ -3287,10 +3301,241 @@ test_61() {
 }
 run_test 61 "default quota tests"
 
+test_62() {
+       ! is_project_quota_supported &&
+               skip "Project quota is not supported"
+        [[ "$(chattr -h 2>&1)" =~ "project" ]] ||
+               skip "chattr did not support project quota"
+       setup_quota_test || error "setup quota failed with $?"
+       local testdir=$DIR/$tdir/
+
+       $RUNAS mkdir -p $testdir || error "failed to mkdir"
+       change_project -s $testdir
+       [[ $($LFS project -d $testdir) =~ "P" ]] ||
+               error "inherit attribute should be set"
+       # chattr used FS_IOC_SETFLAGS ioctl
+       $RUNAS chattr -P $testdir &&
+               error "regular user clear inherit should fail"
+       [[ $($LFS project -d $testdir) =~ "P" ]] ||
+               error "inherit attribute should still be set"
+       chattr -P $testdir || error "root failed to clear inherit"
+       [[ $($LFS project -d $testdir) =~ "P" ]] &&
+               error "inherit attribute should be cleared"
+       cleanup_quota_test
+}
+run_test 62 "Project inherit should be only changed by root"
+
+test_dom() {
+       [ "$MDS1_VERSION" -lt $(version_code 2.11.55) ] &&
+               skip "Not supported before 2.11.55"
+
+       local qtype=$1
+       local qid=$TSTUSR
+       local dd_failed=false
+       local tdir_dom=${tdir}_dom
+       local LIMIT=20480 #20M
+
+       [ $qtype == "p" ] && ! is_project_quota_supported &&
+               echo "Project quota is not supported" && return 0
+
+       [ $qtype == "p" ] && qid=$TSTPRJID
+
+       setup_quota_test || error "setup quota failed with $?"
+       trap cleanup_quota_test EXIT
+
+       quota_init
+
+       # enable mdt/ost quota
+       set_mdt_qtype $QTYPE || error "enable mdt quota failed"
+       set_ost_qtype $QTYPE || error "enable ost quota failed"
+
+       # make sure the system is clean
+       local USED=$(getquota -$qtype $qid global curspace)
+       [ $USED -ne 0 ] && error "Used space for $qid isn't 0."
+
+       chown $TSTUSR.$TSTUSR $DIR/$tdir || error "chown $tdir failed"
+
+       mkdir $DIR/$tdir_dom || error "mkdir $tdir_dom failed"
+       $LFS setstripe -E 1M -L mdt $DIR/$tdir_dom ||
+               error "setstripe $tdir_dom failed"
+       chown $TSTUSR.$TSTUSR $DIR/$tdir_dom || error "chown $tdir_dom failed"
+
+       [ $qtype == "p" ] && {
+               change_project -sp $TSTPRJID $DIR/$tdir
+               change_project -sp $TSTPRJID $DIR/$tdir_dom
+       }
+
+       $LFS setquota -$qtype $qid -b $LIMIT -B $LIMIT $DIR ||
+               error "set $qid quota failed"
+
+       for ((i = 0; i < $((LIMIT/2048)); i++)); do
+               $RUNAS $DD of=$DIR/$tdir_dom/$tfile-$i count=1 oflag=sync ||
+                                                               dd_failed=true
+       done
+
+       $dd_failed && quota_error $qtype $qid "write failed, expect succeed"
+
+       for ((i = $((LIMIT/2048)); i < $((LIMIT/1024 + 10)); i++)); do
+               $RUNAS $DD of=$DIR/$tdir_dom/$tfile-$i count=1 oflag=sync ||
+                                                               dd_failed=true
+       done
+
+       $dd_failed || quota_error $qtype $qid "write succeed, expect EDQUOT"
+
+       rm -f $DIR/$tdir_dom/*
+
+       # flush cache, ensure noquota flag is set on client
+       cancel_lru_locks osc
+       cancel_lru_locks mdc
+       sync; sync_all_data || true
+
+       dd_failed=false
+
+       $RUNAS $DD of=$DIR/$tdir/file count=$((LIMIT/2048)) oflag=sync ||
+               quota_error $qtype $qid "write failed, expect succeed"
+
+       for ((i = 0; i < $((LIMIT/2048 + 10)); i++)); do
+               $RUNAS $DD of=$DIR/$tdir_dom/$tfile-$i count=1 oflag=sync ||
+                                                               dd_failed=true
+       done
+
+       $dd_failed || quota_error $qtype $TSTID "write succeed, expect EDQUOT"
+
+       rm -f $DIR/$tdir/*
+       rm -f $DIR/$tdir_dom/*
+
+       # flush cache, ensure noquota flag is set on client
+       cancel_lru_locks osc
+       cancel_lru_locks mdc
+       sync; sync_all_data || true
+
+       dd_failed=false
+
+       for ((i = 0; i < $((LIMIT/2048)); i++)); do
+               $RUNAS $DD of=$DIR/$tdir_dom/$tfile-$i count=1 oflag=sync ||
+                                                               dd_failed=true
+       done
+
+       $dd_failed && quota_error $qtype $qid "write failed, expect succeed"
+
+       $RUNAS $DD of=$DIR/$tdir/file count=$((LIMIT/2048 + 10)) oflag=sync &&
+               quota_error $qtype $qid "write succeed, expect EDQUOT"
+
+       rm -f $DIR/$tdir/*
+       rm -fr $DIR/$tdir_dom
+
+       $LFS setquota -u $TSTUSR -b 0 -B 0 -i 0 -I 0 $DIR ||
+               error "reset usr quota failed"
+
+       cleanup_quota_test
+}
+
+test_63() {
+       test_dom "u"
+       test_dom "g"
+       test_dom "p"
+}
+run_test 63 "quota on DoM tests"
+
+test_64() {
+       ! is_project_quota_supported &&
+               skip "Project quota is not supported"
+       setup_quota_test || error "setup quota failed with $?"
+       local dir1="$DIR/$tdir/"
+
+       touch $dir1/file
+       ln -s $dir1/file $dir1/file_link
+
+       $LFS project -sp $TSTPRJID $dir1/file_link >&/dev/null &&
+               error "set symlink file's project should fail"
+
+       $LFS project $TSTPRJID $dir1/file_link >&/dev/null &&
+               error "get symlink file's project should fail"
+
+       cleanup_quota_test
+}
+run_test 64 "lfs project on symlink files should fail"
+
+test_65() {
+       local SIZE=10 #10M
+       local TESTFILE="$DIR/$tdir/$tfile-0"
+
+       setup_quota_test || error "setup quota failed with $?"
+       set_ost_qtype $QTYPE || error "enable ost quota failed"
+       quota_init
+
+       echo "Write..."
+       $RUNAS $DD of=$TESTFILE count=$SIZE ||
+               error "failed to write"
+       # flush cache, ensure noquota flag is set on client
+       cancel_lru_locks osc
+       sync; sync_all_data || true
+
+       local quota_u=$($LFS quota -u $TSTUSR $DIR)
+       local quota_g=$($LFS quota -g $TSTUSR $DIR)
+       local quota_all=$($RUNAS $LFS quota $DIR)
+
+       [ "$(echo "$quota_all" | head -n3)" != "$quota_u" ] &&
+               error "usr quota not match"
+       [ "$(echo "$quota_all" | tail -n3)" != "$quota_g" ] &&
+               error "grp quota not match"
+
+       rm -f $TESTFILE
+       # cleanup
+       cleanup_quota_test
+}
+run_test 65 "Check lfs quota result"
+
+test_66() {
+       ! is_project_quota_supported &&
+               skip "Project quota is not supported"
+       setup_quota_test || error "setup quota failed with $?"
+       stack_trap cleanup_quota_test EXIT
+       local old=$(do_facet mds1 $LCTL get_param -n \
+                   mdt.*.enable_chprojid_gid | head -1)
+       local testdir=$DIR/$tdir/foo
+
+       do_facet mds1 $LCTL set_param mdt.*.enable_chprojid_gid=0
+       stack_trap "do_facet mds1 $LCTL set_param mdt.*.enable_chprojid_gid=0" \
+               EXIT
+
+       test_mkdir -i 0 -c 1 $testdir || error "failed to mkdir"
+       chown -R $TSTID:$TSTID $testdir
+       change_project -sp $TSTPRJID $testdir
+       $RUNAS mkdir $testdir/foo || error "failed to mkdir foo"
+
+       $RUNAS lfs project -p 0 $testdir/foo &&
+               error "nonroot user should fail to set projid"
+
+       $RUNAS lfs project -C $testdir/foo &&
+               error "nonroot user should fail to clear projid"
+
+       change_project -C $testdir/foo || error "failed to clear project"
+
+       do_facet mds1 $LCTL set_param mdt.*.enable_chprojid_gid=-1
+       $RUNAS lfs project -p $TSTPRJID $testdir/foo || error \
+       "failed to set projid with normal user when enable_chprojid_gid=-1"
+
+       $RUNAS lfs project -rC $testdir/ || error \
+"failed to clear project state with normal user when enable_chprojid_gid=-1"
+
+       touch $testdir/bar || error "failed touch $testdir/bar"
+       $RUNAS lfs project -p $TSTPRJID $testdir/bar && error \
+       "normal user should not be able to set projid on root owned file"
+
+       change_project -p $TSTPRJID $testdir/bar || error \
+               "root should be able to change its own file's projid"
+
+       cleanup_quota_test
+}
+run_test 66 "nonroot user can not change project state in default"
+
 quota_fini()
 {
        do_nodes $(comma_list $(nodes_list)) "lctl set_param debug=-quota"
-       disable_project_quota
+       if $PQ_CLEANUP; then
+               disable_project_quota
+       fi
 }
 reset_quota_settings
 quota_fini